package cn.ibizlab.businesscentral.core.odoo_base.mapper;

import java.util.List;
import org.apache.ibatis.annotations.*;
import java.util.Map;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import java.util.HashMap;
import org.apache.ibatis.annotations.Select;
import cn.ibizlab.businesscentral.core.odoo_base.domain.Res_currency_rate;
import cn.ibizlab.businesscentral.core.odoo_base.filter.Res_currency_rateSearchContext;
import org.springframework.cache.annotation.CacheEvict;
import org.springframework.cache.annotation.Cacheable;
import java.io.Serializable;
import com.baomidou.mybatisplus.core.toolkit.Constants;
import com.alibaba.fastjson.JSONObject;

public interface Res_currency_rateMapper extends BaseMapper<Res_currency_rate>{

    Page<Res_currency_rate> searchDefault(IPage page, @Param("srf") Res_currency_rateSearchContext context, @Param("ew") Wrapper<Res_currency_rate> wrapper) ;
    @Override
    Res_currency_rate selectById(Serializable id);
    @Override
    int insert(Res_currency_rate entity);
    @Override
    int updateById(@Param(Constants.ENTITY) Res_currency_rate entity);
    @Override
    int update(@Param(Constants.ENTITY) Res_currency_rate entity, @Param("ew") Wrapper<Res_currency_rate> updateWrapper);
    @Override
    int deleteById(Serializable id);
     /**
      * 自定义查询SQL
      * @param sql
      * @return
      */
     @Select("${sql}")
     List<JSONObject> selectBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义更新SQL
    * @param sql
    * @return
    */
    @Update("${sql}")
    boolean updateBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义插入SQL
    * @param sql
    * @return
    */
    @Insert("${sql}")
    boolean insertBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义删除SQL
    * @param sql
    * @return
    */
    @Delete("${sql}")
    boolean deleteBySQL(@Param("sql") String sql, @Param("et")Map param);

    List<Res_currency_rate> selectByCompanyId(@Param("id") Serializable id) ;

    List<Res_currency_rate> selectByCurrencyId(@Param("id") Serializable id) ;

    List<Res_currency_rate> selectByCreateUid(@Param("id") Serializable id) ;

    List<Res_currency_rate> selectByWriteUid(@Param("id") Serializable id) ;


}
